#ifndef BIC_RUNNER_H
#define BIC_RUNNER_H
#include <vector>
using std::vector;

#include "bic_container.h"
#include <thread>
class BIC_Runner
{
    public:
        BIC_Runner(){};
        virtual ~BIC_Runner();

        void pushTask(BIC_Container* task){tasks.push_back(task);};
        void pullTask(BIC_Container* task);
        void setWaitValue(port_t reg0);
        uint32_t getTaskCount(){return tasks.size();};
        bool     getRunning(){return running;};
        void     stopThread(){ if (thread != nullptr) thread -> detach(); running = false; thread = nullptr;};
        BIC_Container*  getCurrentTask(){if (getTaskCount() == 0) return nullptr;
                                         return tasks[tasks.size() - 1];};
        BIC_Container*  getTask(uint32_t task){return tasks[task];};
        void taskCalculateBit(BIC_Container* task);
        void startThread();
        void joinThread(){if (thread != nullptr) thread -> join();};

        static void threadExecute(BIC_Runner* runner);

    private:
        vector <BIC_Container*> tasks;
        port_t  waitPort;   // If type is undefined, there will be waiting
        bool    running = false; // Whether or not our thread is running
        std::thread* thread = nullptr;
};

#endif // BIC_RUNNER_H
