/**
    @author Reuben Shea
    @date   01-06-18

    This project implements a runner for my language BIC.
    It also includes an interface system for GameMaker so that
    compiled BIC code can be passed into this system.

    This project was designed using the c++11 standard and does
    not use any special or platform-specific libraries.
 **/

 /*
    NOTE:   The runner has a few functions that require direct interfacing!
            I have it implemented to interface with GameMaker, but if you wish
            to add your own you will need to modify these as well as add your
            interface functions into interfaces.h
  */

 // -- Local Libraries -- //
#include "properties.h"    // Contains version numbers and desired interfacing function toggles
#include "bic_container.h"  // Defines the "task" class for code containment
#include "bic_runner.h"     // Defines task management and execution
#include "interfaces.h"     // Defines our outside-of-dll interfacing functions

